function [I,O] = buildio(C)
%BUILDIO   Costruzione delle matrici di ingresso e uscita di una rete di Petri dalla matrice di transizione
%
%   function [I,O] = buildio(C)
%   Costruisce le matrici di ingresso e uscita a partire dalla matrice di transizione,
%   dando per scontato che la rete non contenga autoanelli.

elementipositivi = C > 0;
elementinegativi = C < 0;
I = zeros(size(C));
O = zeros(size(C));
for i = 1:size(C,1)
   for j =1:size(C,2)
      if elementinegativi(i,j)
         I(i,j) = -C(i,j);
      elseif elementipositivi(i,j)
         O(i,j) = C(i,j);
      end
   end
end
