function [Cc,M0c] = ibcd(Cp,M0p,L,b)
%IBCD   Invariant Based Control Design
%
%   function [Cc,M0c] = ibcd(Cp,M0p,L,b)
%   Opera la sintesi del supervisore di un modello di un sistema da controllare
%   espresso attraverso una rete di Petri.
%   Cp  la matrice di incidenza della rete di Petri;
%   M0p  la marcatura iniziale della rete;
%   L e b esprimono il vincolo (di tipo forbidden state) da imporre al sistema,
%   nella forma 
%        LMp <= b
%   dove Mp  la marcatura generica della rete;
%   Cc  la matrice di incidenza del controllore;
%   M0c  la marcatura iniziale del controllore.

if L * M0p > b
   disp('Metodo non applicabile: la marcatura iniziale non soddisfa il vincolo.');
   return
end
Cc = -L * Cp;
M0c = b - L * M0p;
