function [CS2,S]=postisif(C,PI,CS,indp)
%POSTISIF 
%
% function [CS2,S]=postisif(C,PI,CS,indp)
% C    = matrice di incidenza
% PI   = P-invarianti associati a C
% CS   = vettore riga (NP elementi di tipo 0 1) del candidato sifone
% indp = indice del posto da cui parte la ricerca dei sifoni
% CS2  = nuovi candidati sifoni ottenuti a partire da CS (CS2=[] se CS e' un sifone)
% S    = eventuali sifoni trovati

CS2 = [];
S = [];
[I,O] = buildio(C);

% Verifica che CS non sia un Pinvariante
if any(sum(abs(PI-ones(size(PI,1),1)*CS)')==0)
%  disp('CS e'' un Pinvariante')
  return
end;

% ind1 = indici delle transizioni del PRE di CS non appartenenti al POST di CS
ind1 = find((-sign(CS*O)+sign(CS*I))<0);

% Se ind1 e' vuoto, CS e' un sifone
if isempty(ind1)
  S = CS;
%  disp('CS e'' un sifone!')
  return
end;

for j=1:length(ind1)
  % ind2 = indici dei posti che hanno le transizioni di ind1 nel POST
  ind2 = find(I(:,ind1(j))>0);
  CS2old = CS;
  CS2 = [];
  for k=1:length(ind2)
    if ind2(k) > indp
      CS2oldb = CS2old;
      CS2oldb(:,ind2(k)) = ones(size(CS2oldb,1),1);
      CS2 = [CS2; CS2oldb];
    end
  end
end
