function S2 = prune(S,PI)
%PRUNE   Pruning dell'insieme generatore di sifoni
%
%   function S2 = prune(S,PI)
%   Effettua il pruning dell'insieme generatore di sifoni
%   Vengono eliminati i sifoni che coincidono con il supporto di Pinvarianti
%   e i sifoni che ne contengono strettamente degli altri.
%   S  = insieme di sifoni non depurato
%   PI = insieme dei P-invarianti
%   S2 = insieme di sifoni depurato

S1 = [];
np = size(S,1);
for i=1:np
  keep = 1;
  PS = [S;S1];
  for j=i+1:size(PS,1)
    if all(S(i,:)-PS(j,:)>=0)
      keep = 0;
      break
    end
  end
  if keep,S1=[S1;S(i,:)];end
end

S2 = [];
ns = size(S1,1);
np = size(PI,1);
for i=1:ns
  keep = 1;
  for j=1:np
    if all(PI(j,:)-S1(i,:)<=0)
      keep = 0;
      break
    end
  end
  if keep,S2=[S2;S1(i,:)];end
end
