function [Cc,M0c] = sifcon(Cp,M0p)
%SIFCON   Calcolo dei sifoni minimi di una rete di Petri
%
%   function [Cc,M0c] = sifcon(Cp,M0p)
%   Costruisce il supervisore atto a controllare con P-invarianti
%   i sifoni di una rete di Petri con matrice di incidenza Cp e marcatura M0p.
%   La sottorete di controllo ha matrice di incidenza Cc e marcatura M0c.

Sold = sifoni(Cp);
% Sel = Sifoni trovati, controllati e quindi eliminati
Sel = [];
while ~isempty(Sold)
     Sold = Sold(1,:);
   L = -Sold;
   b = -ones(size(Sold,1),1);
   [Cc,M0c] = ibcd(Cp,M0p,L,b);
   Cp = [Cp;Cc];
   M0p = [M0p; M0c];
   S = sifoni(Cp);
   % size(S)

   Sold = [Sold zeros(size(Sold,1),size(L,1))];
   if isempty(Sel)
      Sel = Sold;
   else
      Sel = [[Sel zeros(size(Sel,1),size(L,1))]; Sold];
   end;

   for i=1:size(Sel,1)
      for j=1:size(S,1)
         if S(j,:)==Sel(i,:)
            S(j,:) = [];
            % disp('Trovato!')
            break
         end;
      end;
   end;
   Sold = S;
   % size(S)
end;
